Send patches - preferably formatted by git format-patch - to patches at archlinux32 dot org.
summaryrefslogtreecommitdiff
path: root/src/lib/version.sh
diff options
context:
space:
mode:
authorJelle van der Waa <jelle@archlinux.org>2023-11-05 16:11:12 +0100
committerChristian Heusel <christian@heusel.eu>2024-01-10 19:44:15 +0100
commite6f7aa395fabc7eca1ee4d93e454d2551cea505c (patch)
tree57a604c65a7df94072518db91f95f53cd9bbd6b4 /src/lib/version.sh
parente413b65df3dcddeb94da2defb53ab17ef2a8558d (diff)
feat(version): introduce version check subcommand
The version subcommand handles pkgver related commands, the first subcommand being `check`. Check runs nvchecker if a `.nvchecker.toml` file exists and compares the current pkgver with the latest release. Introduces nvchecker as optional dependency which has to be installed in order to use this particular subcommand. BREAKING CHANGE: formerly pkgctl version would output the version of the pkgctl tool, now it is used as a version related subcommand. Fixes #140 Component: pkgctl version Component: pkgctl version check Co-authored-by: Christian Heusel <christian@heusel.eu>
Diffstat (limited to 'src/lib/version.sh')
-rw-r--r--src/lib/version.sh56
1 files changed, 56 insertions, 0 deletions
diff --git a/src/lib/version.sh b/src/lib/version.sh
new file mode 100644
index 0000000..826b306
--- /dev/null
+++ b/src/lib/version.sh
@@ -0,0 +1,56 @@
+#!/hint/bash
+#
+# SPDX-License-Identifier: GPL-3.0-or-later
+
+[[ -z ${DEVTOOLS_INCLUDE_VERSION_SH:-} ]] || return 0
+DEVTOOLS_INCLUDE_VERSION_SH=1
+
+_DEVTOOLS_LIBRARY_DIR=${_DEVTOOLS_LIBRARY_DIR:-@pkgdatadir@}
+
+set -e
+
+
+pkgctl_version_usage() {
+ local -r COMMAND=${_DEVTOOLS_COMMAND:-${BASH_SOURCE[0]##*/}}
+ cat <<- _EOF_
+ Usage: ${COMMAND} [COMMAND] [OPTIONS]
+
+ Package version related commands.
+
+ COMMANDS
+ check Check if there is a newer version availble
+
+ OPTIONS
+ -h, --help Show this help text
+
+ EXAMPLES
+ $ ${COMMAND} check libfoo linux libbar
+_EOF_
+}
+
+pkgctl_version() {
+ if (( $# < 1 )); then
+ pkgctl_version_usage
+ exit 0
+ fi
+
+ while (( $# )); do
+ case $1 in
+ -h|--help)
+ pkgctl_version_usage
+ exit 0
+ ;;
+ check)
+ _DEVTOOLS_COMMAND+=" $1"
+ shift
+ # shellcheck source=src/lib/version/check.sh
+ source "${_DEVTOOLS_LIBRARY_DIR}"/lib/version/check.sh
+ pkgctl_version_check "$@"
+ exit 0
+ ;;
+ *)
+ die "invalid argument: %s" "$1"
+ ;;
+ esac
+ done
+}